functions 5.0 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175
  1. #!/usr/bin/env bash
  2. export ZWAVE_JS_CONF="${SNAP}/lib/zwavejs2mqtt/node_modules/@zwave-js/config"
  3. function ensure_zwavejs_config {
  4. # Not needed anymore as of ZWAVEJS_EXTERNAL_CONFIG
  5. # if [ "$(find ${ZWAVE_JS_CONF} -maxdepth 0 -empty -exec echo empty \;)" == "empty" ]; then
  6. # logger "Config directory is empty, copying data from ${SNAP}/snap/zwave-js/config"
  7. # rsync -raz "${SNAP}/snap/zwave-js/config" "${ZWAVE_JS_CONF}/.."
  8. # else
  9. # logger "Config directory ${ZWAVE_JS_CONF} exists"
  10. # fi
  11. return 0
  12. }
  13. function get_network_key {
  14. if [ -f "${SNAP_DATA}/settings.json" ]; then
  15. SETTINGS_KEY=$(jq '.zwave.networkKey' -r ${SNAP_DATA}/settings.json)
  16. if [ "${SETTINGS_KEY}" != "" ] && [ "${1}" != "${SETTINGS_KEY}" ]; then
  17. echo "${SETTINGS_KEY}"
  18. return 1
  19. fi
  20. return 0
  21. fi
  22. return 0
  23. }
  24. function same_network_key {
  25. # SKIP NOW: NETWORK KEY SHOULD NOT BE USED
  26. # FAVOR SETTING
  27. # if [ -f "${SNAP_DATA}/settings.json" ]; then
  28. # SETTINGS_KEY=$(jq '.zwave.networkKey' -r ${SNAP_DATA}/settings.json)
  29. # if [ "${SETTINGS_KEY}" != "" ] && [ "${1}" != "${SETTINGS_KEY}" ]; then
  30. # echo "${SETTINGS_KEY}"
  31. # return 1
  32. # fi
  33. # return 0
  34. # fi
  35. return 0
  36. }
  37. function cpy_2_zui {
  38. if snapctl is-connected zui-store; then
  39. if [ "$(ls ${SNAP_COMMON}/zui-store) | wc -l" -ne 0 ]; then
  40. echo "The zui-store (${SNAP_COMMON}/zui-store) is not empty, exiting..." >&2
  41. exit 1
  42. elif [ -d "${SNAP_COMMON}/zui-store" ]; then
  43. cp -rf "${SNAP_DATA}/"* "${SNAP_COMMON}/zui-store"
  44. if [ $? -ne 0 ]; then
  45. echo "Failed copying data from ${SNAP_COMMON}/zui-store" >&2
  46. return 1
  47. fi
  48. mv "${SNAP_COMMON}/zui-store/logs" "${SNAP_COMMON}/zui-store/z2m-logs"
  49. else
  50. echo "Missing directory ${SNAP_COMMON}/zui-store, cannot write to it. Exiting..." >&2
  51. exit 1
  52. fi
  53. else
  54. echo "Can not copy config: Missing connection «store-dir» (offered by <zwave-js-ui>: `snap install zwave-js-ui`)." >&2
  55. echo "Please install and connect with:" 1>&2
  56. echo "$ snap connect ${SNAP_NAME}:zui-store zwave-js-ui:store-dir" >&2
  57. return 1
  58. fi
  59. return 0
  60. }
  61. function plug_connected {
  62. if ! snapctl is-connected "${1}"; then
  63. echo "Missing plug: «${1}»" >&2
  64. echo "Connect with:"
  65. if [ "${1}" == "serial-port" ]; then
  66. echo "$ sudo snap connect ${SNAP_NAME}:${1} <slot name>"
  67. else
  68. echo "$ sudo snap connect ${SNAP_NAME}:${1}"
  69. fi
  70. return 1
  71. fi
  72. return 0
  73. }
  74. function plugs_connected {
  75. MISSING=0
  76. RAW_OUT=$(plug_connected "raw-usb")
  77. RAW_RES=$?
  78. SERIAL_OUT=$(plug_connected "serial-port")
  79. SERIAL_RES=$?
  80. if [ $RAW_RES -ne 0 -a $SERIAL_RES -ne 0 ]; then
  81. echo $RAW_OUT
  82. echo "----- OR -----"
  83. echo $SERIAL_OUT
  84. echo "See ${SNAP_NAME}.help for more info on the serial-port plug"
  85. MISSING=1
  86. fi
  87. plug_connected "hardware-observe"
  88. if [ $? -ne 0 ]; then
  89. MISSING=1
  90. fi
  91. if [ $MISSING -ne 0 ]; then
  92. return 1
  93. fi
  94. return 0
  95. }
  96. function is_root {
  97. if [ ${EUID:-$(id -u)} -eq 0 ]; then
  98. return 0
  99. fi
  100. return 1
  101. }
  102. function require_root {
  103. is_root
  104. if [ $? -eq 1 ]; then
  105. echo "Running as root is required." >&2
  106. echo "Re-run with sudo."
  107. exit 1
  108. fi
  109. }
  110. function testnset_config {
  111. logger "${SNAP_NAME}: Testing ${1}, or setting ${2}"
  112. RES=$(snapctl get ${1})
  113. if [ $? -ne 0 ] || [ -z "${RES}" ]; then
  114. logger "${SNAP_NAME}: Setting ${1}=${2}"
  115. RES=$(snapctl set ${1}=${2})
  116. if [ $? -ne 0 ]; then
  117. logger "${RES}"
  118. exit 1
  119. fi
  120. return 0
  121. fi
  122. return 0
  123. }
  124. function test_priority_dir {
  125. Z2M_SETTINGS="${SNAP_DATA}/settings.json"
  126. if ! [ -w "${Z2M_SETTINGS}" ]; then
  127. return 1
  128. fi
  129. PRIORITY_DIR=$(echo "$(sed -E "s#$(dirname ${SNAP_DATA})/(current|[0-9]+)#${SNAP_DATA}#g" <<< $(cat "${Z2M_SETTINGS}" | jq '.zwave.deviceConfigPriorityDir'))" | tr -d '"')
  130. if [[ -d $(dirname "${PRIORITY_DIR}") && -w "${PRIORITY_DIR}" ]]; then
  131. jq --arg deviceConfigPriorityDir ${PRIORITY_DIR} '.zwave.deviceConfigPriorityDir = $deviceConfigPriorityDir' "${Z2M_SETTINGS}" > "${Z2M_SETTINGS}.tmp"
  132. if [ $? -eq 0 ]; then
  133. mv "${Z2M_SETTINGS}.tmp" "${Z2M_SETTINGS}"
  134. fi
  135. elif ! [[ "${PRIORITY_DIR}" =~ ^"$(dirname $SNAP_DATA)"* ]]; then
  136. jq --arg deviceConfigPriorityDir "${SNAP_DATA}/devicePriorityConfig" '.zwave.deviceConfigPriorityDir = $deviceConfigPriorityDir' "${Z2M_SETTINGS}" > "${Z2M_SETTINGS}.tmp"
  137. if [ $? -eq 0 ]; then
  138. mv "${Z2M_SETTINGS}.tmp" "${Z2M_SETTINGS}"
  139. fi
  140. fi
  141. return 0
  142. }
  143. function test_default_config {
  144. testnset_config "server.host" "localhost"
  145. testnset_config "server.port" 8091
  146. testnset_config "server.ssl" false
  147. testnset_config "server.force-disable-ssl" false
  148. testnset_config "session.cookie-secure" $(snap get server.ssl)
  149. testnset_config "session.secret" $(uuid)
  150. testnset_config "mqtt.name" ""
  151. }